#include "./Base.h"
#include "./Derived.h"

#include <stdio.h>

int main() {
  Base b = {333}; // "construct" a Base object
  Derived d = {{593}, 595}; // "construct" a Derived object

  Base* bptr1 = &b;
  Base* bptr2 = (Base*) &d;
  Derived* dptr = &d;

  // static dispatch

  printf("Static Dipatch to call Base::Foo\n");
  base_foo(bptr1);
  base_foo(bptr2);

  printf("\nStatic Dipatch to call Base::Bar\n");
  base_bar(bptr1);
  base_bar(bptr2);

  printf("\nStatic Dipatch to call Derived::Foo\n");
  derived_foo(dptr); 
}
