#ifndef DERIVED_H_
#define DERIVED_H_

#include "./Base.h"

/*
Equivalent of defining:
  class Derived : public Base {
   public:
    void foo();
    void baz();

    // inherits bar from Base

    int y_;
  };
*/

typedef struct derived_st {
  Base base_;
  int y_;
} Derived;

void derived_foo(Derived* this);
void derived_baz(Derived* this);

// void (*derived_vtable[])(Derived*) = {&derived_foo, &base_bar, &derived_baz};

#endif  // DERIVED_H_
